// SPDX-License-Identifier: LGPL-3.0-or-later
// See Notices.txt for copyright information
use fayalite::{
    array::ArrayType,
    hdl,
    int::{IntType, Size, UInt},
};

#[hdl(outline_generated)]
pub struct S<T: IntType, Len: Size> {
    pub a: T,
    b: UInt<3>,
    pub(crate) c: ArrayType<UInt<1>, Len>,
}

#[hdl(outline_generated)]
pub enum E<T> {
    A,
    B(UInt<3>),
    C(T),
}

#[hdl(outline_generated)]
pub struct S2<T = ()> {
    pub v: E<T>,
}
